// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// operator-plugin.go
package expr

import (
	"git.portale-stac.it/go-pkg/expr/kern"
	"git.portale-stac.it/go-pkg/expr/scan"
	"git.portale-stac.it/go-pkg/expr/sym"
)

//-------- plugin term

func newPluginTerm(tk *scan.Token) (inst *scan.Term) {
	return &scan.Term{
		Tk:       *tk,
		Children: make([]*scan.Term, 0, 1),
		Position: scan.PosPrefix,
		Priority: scan.PriSign,
		EvalFunc: evalPlugin,
	}
}

func evalPlugin(ctx kern.ExprContext, opTerm *scan.Term) (v any, err error) {
	var childValue any
	var count int

	if childValue, err = opTerm.EvalPrefix(ctx); err != nil {
		return
	}

	if count, err = importPluginFromSearchPath(ctx, childValue); err == nil {
		v = int64(count)
	}
	return
}

// init
func init() {
	scan.RegisterTermConstructor(sym.SymKwPlugin, newPluginTerm)
}
